#ifndef BOOTTEST_H
#define BOOTTEST_H

// size of memory operands
typedef   signed  char      bit8s;
typedef unsigned  char      bit8u;
typedef   signed short      bit16s;
typedef unsigned short      bit16u;
typedef   signed  long      bit32s;
typedef unsigned  long      bit32u;
#ifdef _MSC_VER
  typedef   signed  _int64  bit64s;  // Microsoft specific
  typedef unsigned  _int64  bit64u;  // Microsoft specific
#elif defined DJGPP
  typedef   signed       char  bool
  typedef   signed  long long  bit64s;
  typedef unsigned  long long  bit64u;
#else
# error 64 bit types not defined
#endif

#pragma pack(push, 1)

struct S_CHS_FIELDS {
  bit8u  head;       // 8 bits
  bit8u  sector;     // hi 2 bits = hi 2 bits of cyl, low 6 bits = sector
  bit8u  cylinder;   // low 8 bits of 10 bit cyl
};

struct S_PART_ENTRY {
  bit8u  boot_id;
  struct S_CHS_FIELDS start;
  bit8u  sys_id;
  struct S_CHS_FIELDS end;
  bit32u start_lba;
  bit32u size;
};

struct S_MBR {
  bit8u  boot[446];
  struct S_PART_ENTRY part_entry[4];
  bit16u sig;
};

#pragma pack(pop)


bool does_file_exist(const char *filename);
void generate_sequence(int *sequ);
void calc_chs_from_lba(struct S_CHS_FIELDS *chs, const bit32u lba);




#endif  // BOOTTEST_H