
; make the target file 'loader.sys'
outfile loader.sys

.model tiny
.code
.386

           ; we are at physical address 0x30000
           org  00h
           
           push eax
           call save_eip
           sub  eax,($ - 00h)   ; here minus origin of 00h
           mov  saved_eip,eax
           pop  eax
           
           push esp
           push 0
           push ss
           push 0
           push ds
           push dword saved_eip
           push 0
           push cs
           push edi
           push esi
           push edx
           push ecx
           push ebx
           push eax
           
           mov  si,offset string
           call display_string
           
           ; now print the register contents
           mov  si,offset regs_strings
@@:        cmp  byte [si],0
           je   short here
           call display_string
           pop  eax
           call display_eax
           jmp  short @b
           
           ; now just "freeze"
here:      jmp short here
           
save_eip   proc near
           pop  eax
           push eax
           ret
save_eip   endp

; on entry, ds:si -> asciiz string to display
; does not save the si register so that we may
;  advance to the next string for next time
display_string proc near uses ax  bx
@@:        lodsb
           or   al,al
           jz   short @f
           xor  bx,bx
           mov  ah,0Eh
           int  10h
           jmp  short @b
@@:        ret
display_string endp

; display the value of eax to the screen
display_eax proc near uses eax ebx ecx edx
           mov  ecx,8
@@:        rol  eax,04         ;
           push eax            ;
           and  al,0Fh         ;
           daa                 ;
           add  al,0F0h        ;
           adc  al,40h         ;
           mov  ah,0Eh
           xor  bx,bx
           int  10h
           pop  eax            ;
           loop @b             ;
           ret
display_eax endp

saved_eip     dd 0

string        db  13,10,'Congratulations, you have successfully loaded this file...',0

regs_strings  db  13,10,'eax = ',0
              db  13,10,'ebx = ',0
              db  13,10,'ecx = ',0
              db  13,10,'edx = ',0
              db  13,10,'esi = ',0
              db  13,10,'edi = ',0
              db  13,10,' cs = ',0
              db  13,10,' ip = ',0
              db  13,10,' ds = ',0
              db  13,10,' ss = ',0
              db  13,10,' sp = ',0
              db  0

.end
